﻿EnableExplicit

;- -- Information.
; Dieses Modul ist die Hauptdatei des Projekts.

;- -- Version 01.
; Status:   In Arbeit.
; Autor:    Peter Dreisiebner
; Website:  http://peter.dreisiebner.at
; E-Mail:   web@dreisiebner.at
; Geändert: 2017-10-13 - PureBasic v5.61 (x86).


;
;- -- Include.
;
#PBIncludePath = "_ PureBasic\"
XIncludeFile "Common.pbi"
XIncludeFile #PBIncludePath + "Macros-v01.pbi"
XIncludeFile #PBIncludePath + "DebugView-v02.pbi"
XIncludeFile #PBIncludePath + "Tool-v01.pbi"
XIncludeFile #PBIncludePath + "WindowLog-v01.pbi"
XIncludeFile #PBIncludePath + "WindowAbout-v01.pbi"
XIncludeFile "WindowStart.pbi"


;-
;- -- DeclareModule Application.
;
DeclareModule Application
   EnableExplicit

   Declare.i Main()

EndDeclareModule  ; Application.


;-
;- -- Main - Programmstart.
;
; Hinweis für die Debugversion ausgeben.
CompilerIf #fDebugOut = #True
   CompilerIf #fDebugWindowLog = #True
      MessageRequester(#sApplicationName, "Debugversion für das Log-Fenster.")
   CompilerElse
      MessageRequester(#sApplicationName, "Debugversion für DebugView.")
   CompilerEndIf
CompilerEndIf
; Programm starten.
End Application::Main()


;-
;- -- Module Application.
;
Module Application
   EnableExplicit
   UseModule Common
   DebugOutApplication
   
   ;-
   ;- --Konstanten.
   
   ;-
   ;- -- Variablen.
   Global  miWindowStartNumber.i
   
   ;-

   Procedure.i Main()
      ; Programm starten.
      DebugView::Start("Programm >" + #sApplicationName + "< gestartet.")
      DebugView::ProcIn()
      WindowLog::Load()
      Protected iEvent.i, iWindow.i, iExit.i, iReturn.i

      ; Das Hauptprogrammfenster anzeigen.
      miWindowStartNumber = WindowStart::Open()
      If (Not miWindowStartNumber)
         iReturn = 255  ; Fehlernummer für Programmende, hat noch keine bestimmte Bedeutung.
      Else

         ; Programmschleife.
         Repeat
            iEvent = WaitWindowEvent()

            ; Das Programm beenden.
            If (#eCustomEventExitApplication = iEvent)
               iExit = #True
            EndIf

         Until iExit

      EndIf ; (Not miWindowStartNumber).

      WindowLog::Close(#True)
      DebugView::ProcOut()
      DebugView::Exit("Programm >" + #sApplicationName + "< beendet.")
      ProcedureReturn iReturn
   EndProcedure


EndModule   ; Application.
